﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;

namespace MPP
{
    class Class1 : MonoBehaviour
    {
        public Vector3 NextCamPos;
        public float NextCamZoom;
        public float CamSpeed = 0.02f;
        public AudioSource GamAuds;
        public List<AudioClip> clips = new List<AudioClip>();
        public Texture2D WilsonSkin;
        public Sprite mppLogo;
        public string ModTag;
        public Sprite wilsonLogo;
        public GameObject Wilson;
        GameObject Instance;
        GameObject CreditHolder;

        public void Start()
        {
            clips = GameObject.Find("gnfjgfjfgioj").GetComponent<ResourceStorage>().WebSounds;
            WilsonSkin = GameObject.Find("gnfjgfjfgioj").GetComponent<ResourceStorage>().textures[0];
            mppLogo = GameObject.Find("gnfjgfjfgioj").GetComponent<ResourceStorage>().sprites[0];
            wilsonLogo = GameObject.Find("gnfjgfjfgioj").GetComponent<ResourceStorage>().sprites[1];
            GameObject.FindObjectOfType<ClearButtonBehaviour>().ClearEverything();
            Destroy(GameObject.FindObjectOfType<ToolControllerBehaviour>());
            Destroy(GameObject.FindObjectOfType<UndoControllerBehaviour>());
            GameObject Fader = new GameObject();
            Fader.AddComponent<SnapFade>().StartColor = Color.black;
            Fader.GetComponent<SnapFade>().WaitTilFadeTime = 2;
            Fader.GetComponent<SnapFade>().FadeTime = 4;
            Destroy(GameObject.Find("WORLD").transform.GetChild(0).GetChild(0).gameObject);
            Instance = Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            Instance.GetComponent<SpriteRenderer>().sprite = GameObject.Find("gnfjgfjfgioj").GetComponent<ResourceStorage>().sprites[2];  //get the SpriteRenderer and replace its sprite with a custom one          
            Instance.AddComponent<AudioSource>().spatialBlend = 1;
            Instance.AddComponent<WalkieTalkie>();
            AudioSource audio = Instance.AddComponent<AudioSource>();
            audio.spatialBlend = 1;
            Instance.FixColliders();

            Vector2[] ColliderPoints = new Vector2[]
            {
new Vector2(-0.01537222f,0.1695256f)
,new Vector2(-0.04180238f,0.1708492f)
,new Vector2(-0.04160103f,0.05049873f)
,new Vector2(-0.04082019f,0.04340563f)
,new Vector2(-0.0612586f,0.04356253f)
,new Vector2(-0.06282882f,-0.1519364f)
,new Vector2(0.06211817f,-0.1520159f)
,new Vector2(0.06111239f,0.04104583f)
,new Vector2(-0.01635181f,0.0433831f)
            };

            Instance.GetComponent<PolygonCollider2D>().SetPath(0, ColliderPoints);
            Wilson = Instantiate(ModAPI.FindSpawnable("Human").Prefab, new Vector3(-1.2f, 0, ModAPI.FindSpawnable("Human").Prefab.transform.position.z), Quaternion.identity, null);
            Wilson.GetComponent<PersonBehaviour>().SetBodyTextures(WilsonSkin);
            Instance.transform.position = new Vector3(0.3f, -2.6f, 0);
            Instance.GetComponent<AudioSource>().clip = clips[0];
            Instance.GetComponent<AudioSource>().loop = true;
            Instance.GetComponent<AudioSource>().Play();
            GamAuds = Instance.AddComponent<AudioSource>();
            GamAuds.spatialBlend = 1;
            GamAuds.clip = clips[1];
            Destroy(GameObject.FindObjectOfType<CatalogBehaviour>().transform.root.gameObject);
            Destroy(GameObject.FindObjectOfType<CameraControlBehaviour>());
            Instantiate<GameObject>(MapRegistry.GetAllMaps().ToArray()[10].Prefab, Vector3.zero, Quaternion.identity, null);
            Global.main.camera.transform.position = new Vector3(0.3f, -2.6f, -10.0f);
            Global.main.camera.orthographicSize = 0.3543122f;
            NextCamPos = new Vector3(0.3f, -2.6f, -10.0f);
            NextCamZoom = 0.3543122f;
            StartCoroutine(Sequence());

        }


        public void Update()
        {
            Global.main.camera.transform.position = Vector3.Lerp(Global.main.camera.transform.position, NextCamPos, CamSpeed * Time.deltaTime);
            Global.main.camera.orthographicSize = Mathf.Lerp(Global.main.camera.orthographicSize, NextCamZoom, CamSpeed * Time.deltaTime);
            if (Global.main.Paused)
                Global.main.TogglePaused();
            if (Global.main.ShowLimbStatus)
                Global.main.ToggleLimbStatus();
            if (Global.main.SlowMotion)
                Global.main.ToggleSlowmotion();

            if (CreditHolder)
            {
                CreditHolder.GetComponent<RectTransform>().anchoredPosition = Vector2.Lerp(CreditHolder.GetComponent<RectTransform>().anchoredPosition, new Vector2(0, 5605.6f),0.02255f * Time.deltaTime);
            }

                
        }


        IEnumerator Sequence()
        {
            yield return new WaitForSeconds(2f);
            GamAuds.Play();
            yield return new WaitForSeconds(2f);
            GameObject song = new GameObject();
            song.AddComponent<AudioSource>();
            song.GetComponent<AudioSource>().clip = clips[3];
            song.GetComponent<AudioSource>().Play();
            NextCamPos = new Vector3(0.0f, -0.2f, -10.0f);
            NextCamZoom = 8f;
            yield return new WaitForSeconds(18f);
            song.GetComponent<AudioSource>().PlayOneShot(clips[2]);
            yield return new WaitForSeconds(3f);
            GameObject Fader = new GameObject();
            Fader.AddComponent<SnapFade>().StartColor = Color.black;
            Fader.GetComponent<SnapFade>().WaitTilFadeTime = 2;
            Fader.GetComponent<SnapFade>().FadeTime = 4;
            Destroy(Wilson);
            Destroy(Wilson);
            Destroy(Instance);
            Destroy(GameObject.FindObjectOfType<MapConfig>().gameObject);
            yield return new WaitForSeconds(2.6f);
            GameObject Canvas = OtherStuff.CreateCanvas(true,false);

            
            {
                CreditHolder = UiCreatingStuff.CreatePanel(Canvas, Vector2.one * 600, new Vector3(0, -981.32f, 0));
                CreditHolder.AddComponent<VerticalLayoutGroup>().childAlignment = TextAnchor.UpperCenter;
                CreditHolder.GetComponent<VerticalLayoutGroup>().childControlHeight = false;
                CreditHolder.GetComponent<VerticalLayoutGroup>().childControlWidth = false;
                CreditHolder.GetComponent<VerticalLayoutGroup>().childForceExpandHeight = false;

                GameObject mpp = UiCreatingStuff.CreatePanel(CreditHolder, new Vector2(1136.3f, 688.8f), Vector3.zero, 1);
                mpp.GetComponent<Image>().color = Color.white;
                mpp.GetComponent<Image>().sprite = mppLogo;

                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);

                UiCreatingStuff.CreateText(CreditHolder, "Team Wilson", Vector3.zero, new Vector2(2346.903f, 150), 100);

                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);

                UiCreatingStuff.CreateText(CreditHolder, "Camdog74 - Programmer, Artist, Sound Design, Video Editor", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "TheRogueEight - Artist, Community Manager, Voice Actor", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Gambit - Artist, Event Manager, Voice Actor, Video Editor", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Aspa102 - Programer", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "MozieJ - Lead Human", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);

                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);

                UiCreatingStuff.CreateText(CreditHolder, "Team Wilson Associates", Vector3.zero, new Vector2(2346.903f, 150), 100);
                UiCreatingStuff.CreateText(CreditHolder, "GrinnyBeanie - Art Assistance", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "FriedFox - General Assistance", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);

                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);

                UiCreatingStuff.CreateText(CreditHolder, "Community skin creators", Vector3.zero, new Vector2(2346.903f, 100), 100);

                UiCreatingStuff.CreateText(CreditHolder, "GrinnyBeanie", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Frevv", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "AnOtheruu", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "FriedFox", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "ManOfX", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "fR4n1oo0", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "lake", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Spidey", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Your Casual Demon", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Scar", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);

                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);

                UiCreatingStuff.CreateText(CreditHolder, "Special Thanks", Vector3.zero, new Vector2(2346.903f, 100), 100);

                UiCreatingStuff.CreateText(CreditHolder, "Talonphobia", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "mlgthatsme", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Ang543", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Fsman", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "Zooi (mestiez)", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);
                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);
                UiCreatingStuff.CreateText(CreditHolder, "", Vector3.zero, new Vector2(2346.903f, 200), 100);
                UiCreatingStuff.CreateText(CreditHolder, "Wilson will return in...", Vector3.zero, new Vector2(2346.903f, 100), 54.6f);


                GameObject twm = UiCreatingStuff.CreatePanel(CreditHolder, new Vector2(1136.3f, 688.8f), Vector3.zero, 1);
                twm.GetComponent<Image>().color = Color.white;
                twm.GetComponent<Image>().sprite = wilsonLogo;
                yield return new WaitForSeconds(95f);

                UnityEngine.SceneManagement.SceneManager.LoadScene(0);

            }






        }
    }
}
